﻿using System;
using Shared;
namespace HDL_ON.UI.UI2.Intelligence.Automation.LogicView
{
    public class AddOutputInputView
    {
        /// <summary>
        /// 主控件View
        /// </summary>
        public FrameLayout frameLayout = new FrameLayout
        {
            Height = Application.GetRealHeight(44),
            Width = Application.GetRealWidth(343),
            BackgroundColor = CSS.CSS_Color.view,
            X = Application.GetRealWidth(LogicView.TextSize.left16),
        };

        /// <summary>
        /// 主控件View
        /// </summary>
        public RowLayout rowLayout = new RowLayout
        {
            Height = Application.GetRealHeight(43),
            Width = Application.GetRealWidth(343),
            LineColor = CSS.CSS_Color.viewTranslucence,
            SubViewWidth = Application.GetRealWidth(68),
        };
        /// <summary>
        /// （条件或者目标）图标
        /// </summary>
        public Button btnIcon = new Button
        {
            Width = Application.GetRealWidth(28),
            Height = Application.GetRealWidth(28),
            //Y = Application.GetRealHeight(8),
            X = Application.GetRealWidth(TextSize.left12),

        };
        /// <summary>
        /// （条件或者目标）文本描述
        /// </summary>
        public Button btnText = new Button
        {
            TextSize = TextSize.text14,
            Width = Application.GetRealWidth(250),
            Height = Application.GetRealHeight(20),
            TextColor = CSS.CSS_Color.textColor,
            //Y=Application.GetRealHeight(12),
            X = Application.GetRealWidth(52),
        };

        /// <summary>
        /// （条件或者目标）设备状态文本描述
        /// </summary>
        public Button btnState = new Button
        {
            TextSize = TextSize.text12,
            Width = Application.GetRealWidth(130),
            Height = Application.GetRealHeight(17),
            TextColor = CSS.CSS_Color.textCancelColor,
            Y = Application.GetRealHeight(14),
            X = Application.GetRealWidth(165),
            TextAlignment = TextAlignment.CenterRight,
        };

        /// <summary>
        /// （条件或者目标）图标
        /// </summary>
        public Button btnNextIcon = new Button
        {
            Width = Application.GetRealWidth(16),
            Height = Application.GetRealWidth(16),
            UnSelectedImagePath = "LogicIcon/next.png",
            //Y = Application.GetRealHeight(14),
            X = Application.GetRealWidth(315),

        };

        /// <summary>
        /// 线
        /// </summary>
        public Button btnLine = new Button
        {
            Width = Application.GetRealWidth(279),
            Y = Application.GetRealHeight(44 - 1),
            X = Application.GetRealWidth(52),
            Height = 1,
            BackgroundColor = CSS.CSS_Color.viewLine,

        };
        /// <summary>
        /// 延时
        /// </summary>
        public Button btnDelay = new Button
        {
            BackgroundColor = CSS.CSS_Color.AuxiliaryColor1,
            TextID = StringId.delayLogic,
            TextSize = LogicView.TextSize.text16,
            TextColor = CSS.CSS_Color.view,
        };
        /// <summary>
        /// 删除
        /// </summary>
        public Button btnDel = new Button
        {
            BackgroundColor = CSS.CSS_Color.textRedColor,
            TextID = StringId.Del,
            TextSize = LogicView.TextSize.text16,
            TextColor = CSS.CSS_Color.view,
        };
        public Button btnClick = new Button
        {
            Height = Application.GetRealHeight(44),
            Width = Application.GetRealWidth(343),
        };
        /// <summary>
        /// View的方法
        /// </summary>
        /// <returns></returns>
        public void FLayoutView(VerticalScrolViewLayout verticalScrolView)
        {
            verticalScrolView.AddChidren(frameLayout);
            frameLayout.AddChidren(rowLayout);
            btnIcon.Gravity = Gravity.CenterVertical;
            btnText.Gravity = Gravity.CenterVertical;
            btnText.TextAlignment = TextAlignment.CenterLeft;
            btnNextIcon.Gravity = Gravity.CenterVertical;
            rowLayout.AddChidren(btnIcon);
            rowLayout.AddChidren(btnText);
            rowLayout.AddChidren(btnState);
            rowLayout.AddChidren(btnNextIcon);
            rowLayout.AddRightView(btnDelay);
            rowLayout.AddRightView(btnDel);
            rowLayout.AddChidren(btnClick);
            btnLine.Y = frameLayout.Height - 1;
            frameLayout.AddChidren(btnLine);

        }

    }
}
