﻿using System;
using Shared;
namespace HDL_ON.UI.UI2.Intelligence.Automation.LogicView
{
    public class TimeHorizonView : FrameLayout
    {
        /// <summary>
        /// 主控件
        /// </summary>
        public FrameLayout frameLayout = new FrameLayout
        {
            Y = Application.GetRealHeight(460),
            Height = Application.GetRealHeight(187),
            Width = Application.GetRealWidth(343),
            X = Application.GetRealWidth(16),
            BackgroundColor = CSS.CSS_Color.view,
            Radius=(uint)Application.GetRealHeight(12),
        };
        /// <summary>
        /// 标题Btn
        /// </summary>
        public Button btnTitle = new Button
        {
            TextID = StringId.timeHorizon,
            TextSize = TextSize.text16,
            TextColor = CSS.CSS_Color.textColor,
            IsBold = true,
            Width = Application.GetRealWidth(343-(52 + 4 + 10)*2),
            Height = Application.GetRealHeight(22),
            Y = Application.GetRealHeight(15),
            X = Application.GetRealWidth(52 + 4 + 10)
        };
        /// <summary>
        /// 取消Btn
        /// </summary>
        public Button btnCancel = new Button
        {
            TextID = StringId.cancelSelected,
            TextSize = TextSize.text14,
            TextColor = CSS.CSS_Color.textCancelColor,
            Width = Application.GetRealWidth(52),
            Height = Application.GetRealHeight(32),
            Y = Application.GetRealHeight(10),
            X = Application.GetRealWidth(4)
        };
        /// <summary>
        /// 确定Btn
        /// </summary>
        public Button btnConfirm = new Button
        {
            TextID = StringId.confirmSelected,
            TextSize = TextSize.text14,
            TextColor = CSS.CSS_Color.textConfirmColor,
            Width = Application.GetRealWidth(52),
            Height = Application.GetRealHeight(32),
            X = Application.GetRealWidth(343 - 4 - 52),
            Y = Application.GetRealHeight(10),
        };
        /// <summary>
        ///  红色提示文本
        /// </summary>
        public Button btnTip = new Button
        {
            TextID = StringId.timeTipText,
            TextSize = TextSize.text12,
            TextColor = CSS.CSS_Color.textRedColor,
            Width = Application.GetRealWidth(340 - 20-20),
            Height = Application.GetRealHeight(24),//17
            X = Application.GetRealWidth(20),
            Y = Application.GetRealHeight(58),
            TextAlignment = TextAlignment.CenterLeft,
            IsMoreLines=true,
        };

        /// <summary>
        /// View的方法
        /// </summary>
        /// <returns></returns>
        public void FLayoutView(FrameLayout fLayout)
        {
            frameLayout.AddChidren(btnTitle);
            frameLayout.AddChidren(btnTip);
            frameLayout.AddChidren(btnCancel);
            frameLayout.AddChidren(btnConfirm);
            fLayout.AddChidren(frameLayout);
            ////界面点击事件
            //fLayout.MouseUpEventHandler += (sender, e1) =>
            //{
            //    //移除fLayout界面
            //    fLayout.RemoveFromParent();
            //};
            //取消点击事件
            btnCancel.MouseUpEventHandler += (sender, e2) =>
            {
                //移除fLayout界面
                fLayout.RemoveFromParent();
            };
        }
    }
}
